/*
 * Meta, Geoffrey's self-balancing ride-on robot.
 * 
 * Copyright (C) 2006-2007 Geoffrey D. Bennett <g@netcraft.com.au>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#ifndef _HARDWARE_H_
#define _HARDWARE_H_

#define CPUCLK 8000000
#define BAUDRATE 38400
#define UBRR_INIT ((CPUCLK / 16 / BAUDRATE) - 1)

/* counter for timing the main loop
 * prescale clk/1024
 */
#define TCCR0_INIT ((1<<CS02) | (1<<CS00))

/* motor -- phase correct 8-bit PWM, clk/1 (no prescaling) */
#define TCCR1A_INIT ((1 << COM1A1) | (1 << COM1B1) | (1 << WGM10))
#define TCCR1B_INIT (1 << CS10)

/* counter for timing the RC pulses
 * prescale clk/256
 */
#define TCCR2_INIT ((1<<CS22) | (1<<CS21))

/* see hardware */
#define DDRA_INIT 0xC0
#define PORTA_INIT 0xC0
#define DDRB_INIT 0x03
#define PORTB_INIT 0xF7
#define DDRC_INIT 0xFC
#define PORTC_INIT 0x0F
#define DDRD_INIT 0xF2
#define PORTD_INIT 0xCD

/* rising edge interrupt on INT0 and INT1 for RC pulse timing */
#define MCUCR_INIT ((1<<ISC11) | (1<<ISC10) | (1<<ISC00) | (1<<ISC01))

/* enable interrupts for INT0 and INT1 */
#define GICR_INIT ((1<<INT0) | (1<<INT1))

#endif
