/*
 * Meta, Geoffrey's self-balancing ride-on robot.
 * 
 * Copyright (C) 2006 Trevor Blackwell <tlb@tlb.org>
 * Copyright (C) 2006-2007 Geoffrey D. Bennett <g@netcraft.com.au>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#ifndef _UART_H_
#define _UART_H_

#include <inttypes.h>

extern void uart_init(void);
extern void putc(uint8_t c);
extern uint8_t uart_send_empty(void);
extern uint8_t uart_tx_qlen(void);
extern void uart_flush(void);

void log_str(const char *s);
void log_nybble(uint8_t x);
void log_uint8(uint8_t x);
void log_uint16(uint16_t x);
void log_float(float x);

extern char getc(void);

#endif
